﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace JednorozmernePoleWPF
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        #region Datové složky třídy (globální proměnné)
        // Specifikace konstanty a inicializace
        const int Max = 10;
        // Aktuální rozměr pole - počet prvků
        private int pocetPrvku;
        // Přípustná minimální hodnota (dolní mez) prvku - inicializace
        private int minHodnota = 1;
        // Přípustná maximální hodnota (horní mez) prvku - inicializace
        private int maxHodnota = 100;

        // Deklarace pole
        private int[] pole;

        #endregion Datové složky třídy 

        public MainWindow()
        {
            InitializeComponent();

            /* Přiřazení maximálního rozměru vektoru do datové složky určující
             * počet prvků vektoru */
            this.pocetPrvku = Max;

            // Vytvoření instance (objektu) pole s definovanou délkou
            this.pole = new int[this.pocetPrvku];

            /* Přiřazení počtu prvků vektoru do objektu na formuláři určujícího
             * velikost vektoru*/
            this.TxtPocetPrvku.Text = this.pocetPrvku.ToString();

            /* Přiřazení přípustné minimální hodnoty prvku ve vektoru do objektu 
             * na formuláři určujícího mezní hodnotu */
            this.TxtMinHodnota.Text = this.minHodnota.ToString();

            /* přiřazení přípustné maximální hodnoty prvku ve vektoru do objektu (pole) 
             * na formuláři určujícího mezní hodnotu */
            this.TxtMaxHodnota.Text = this.maxHodnota.ToString();
        }

        #region Události
        private void TxtPocetPrvku_LostFocus(object sender, RoutedEventArgs e)
        {
            // Lokální proměnná pro uložení nového počtu prvků vektoru
            //int novaHodnota;

            if (int.TryParse(this.TxtPocetPrvku.Text, out int novaHodnota) == false)
            {
                MessageBox.Show("Zadán špatný počet prvků!");
                return;
            }

            if ((novaHodnota > Max) || (novaHodnota < 1))
            {
                MessageBox.Show($"Chyba velikost vektoru, nastavení na max. rozměr: {Max}");
                /* Přiřazení maximálního rozměru vektoru do lokální proměnné určující
                 * počet prvků vektoru */
                novaHodnota = Max;
                /* Přiřazení maximálního rozměru vektoru do objektu na formuláři
                 * určující počet prvků vektoru */
                this.TxtPocetPrvku.Text = novaHodnota.ToString();
            }
            
            // Pokud nový rozměr vektoru není stejný jako stávající počet prvků vektoru, pak...
            if (novaHodnota != this.pocetPrvku)
            {
                // Uložení nového rozměru pole do datové složky třídy
                this.pocetPrvku = novaHodnota;
                // Vytvoření nové instance pole s novým rozměrem
                this.pole = new int[novaHodnota];

            }


        }

        }
        #endregion Události
    }
}
